
// #define F_CPU 12000000UL
#define F_CPU 11059200UL

#define F_BOOT 100000UL
    // this is already shifted.. the control byte looks like:
    //
    //   1 0 1 0 A2 A1 A0 RW
#define BC_ADDR  0xa0  


   // VCC to target chip on and off, default is on.
#define RELAY_VCC  (C,2)

   // power selector, default is to power the target MCU via
   // the target circuit power connectors
#define RELAY_PSEL (C,0)

  // this one has the RESET and MOSI lines
#define RELAY_PRG1 (B,2)

  // this one has the SCK and MISO lines
#define RELAY_PRG2 (B,1)


#define PMAVR_SCK       (B,5)
#define PMAVR_MISO      (B,4)
#define PMAVR_MOSI      (B,3)
#define PMAVR_RESET     (B,0)

