#include <stdlib.h>
#include <string.h>
#include <stdint.h>
#include <stdio.h>

#define  SIZE 1024

uint8_t buffer[SIZE];
int head, tail;

int main(int argc,char **argv)
{
  char *A, *B;
  int L,i,eof;
  A= argv[1]; B= argv[2];
  L= strlen(A);
  if (strlen(B)!=L) { printf("string lengths do not match\n"); return 1;}
  eof= 0;

fill:
    while((tail+1)%SIZE!=head)
    {
       if (fread(buffer+tail, 1,1, stdin)!=1) { eof= 1; break; }
       tail= (tail+1)%SIZE;
    }

look:
    if (head==tail) { if (eof) goto done; goto fill; }

    if (buffer[head]!=A[0]) goto copy;

    for(i=0;A[i];i++)
    {
      if ((head+i)%SIZE==tail) { if (!eof) goto fill; goto copy; }
      if (A[i]!=buffer[(head+i)%SIZE]) goto copy;
    }
    fwrite(B, 1, strlen(B), stdout);
    head= (head+strlen(B))%SIZE;
    goto look;

copy:
    fwrite(buffer+head, 1,1, stdout);
    head= (head+1)%SIZE;
    goto look;
done:
    return 0;
}
