	.text
	.globl coth_switch
	.type coth_switch,@function
coth_switch:
	/* standard entry code for functions with local variables */
	pushq	%rbp
	movq	%rsp, %rbp

	/* from this point on, we don't need %esp, so we can use it
        as a pointer to the data structure holding the source context */
	movq %rdi, %rsp
	/* we need 15 quads to store the registers */
	addq $120, %rsp
       
	pushq %r15
	pushq %r14
	pushq %r13
	pushq %r12
	pushq %r11
	pushq %r10
	pushq %r9
	pushq %r8
	pushq %rax
	pushq %rbx
	pushq %rcx
	pushq %rdx
	pushq %rsi
	pushq %rdi
	pushq %rbp

	/* now all registers are free, we can load them from the 
	destination context. */

	movq %rsi, %rsp
	popq %rbp
	popq %rdi
	popq %rsi
	popq %rdx
	popq %rcx
	popq %rbx
	popq %rax
	popq %r8
	popq %r9
	popq %r10
	popq %r11
	popq %r12
	popq %r13
	popq %r14
	popq %r15

	/* now, ebp = ebp of the destination context. simply running
           leave, ret will store ebp back into esp and return. nice. */
	leave
	ret
	.size coth_switch, . - coth_switch
